/*******************************************************************
 * 							 Touchdown Software
 *
 *		 Copyright(c) 1997, Palm Computing Inc., All Rights Reserved
 *
 *-------------------------------------------------------------------
 * FileName:
 *		MemoDB.h
 *
 * Description:
 *		Header for the Memo Manager
 *
 * History:
 *   	1/3/95	rsf - Created
 *   	9/13/95	mlb - added memo item type and MemoNewRecord
 *
 *******************************************************************/

#ifndef __TDMEMOMGR_H__
#define __TDMEMOMGR_H__

#define LocalizedAppInfoStr			1000

typedef struct {
   UInt	renamedCategories;		// bitfield of categories with a different name
	char	categoryLabels[dmRecNumCategories][dmCategoryLength];
	Byte	categoryUniqIDs[dmRecNumCategories];
	Byte	lastUniqID;			// Uniq IDs generated by the device are between
									// 0 - 127.  Those from the PC are 128 - 255.
	Byte	reserved1;			// from the compiler word aligning things
	Word	reserved2;
	Word	reserved3;
	Byte	sortOrder;
} MemoAppInfoType;

typedef MemoAppInfoType * MemoAppInfoPtr;


// Sort orders
#define soUnsorted		0
#define soAlphabetic	1


typedef struct {
	char 	note;		// null terminated
} MemoDBRecordType;

typedef MemoDBRecordType * MemoDBRecordPtr;

typedef struct {
	CharPtr				note;
} MemoItemType;

typedef MemoItemType * MemoItemPtr;


#ifdef __cplusplus
extern "C" {
#endif


//-------------------------------------------------------------------
// Routines
//-------------------------------------------------------------------
extern Err	MemoAppInfoInit(DmOpenRef dbP);

extern Err	MemoNewRecord(DmOpenRef dbP, MemoItemPtr item, UInt *index);

extern Err	MemoChangeSortOrder(DmOpenRef dbP, Byte sortOrder);

extern Byte	MemoGetSortOrder (DmOpenRef dbP);

extern void	MemoSort (DmOpenRef dbP);

extern Err	MemoSortRecord (DmOpenRef dbP, WordPtr indexP);


#ifdef __cplusplus
}
#endif


#endif
