/*
 * Copyright (c) 1999 Horace Ho
 * All rights reserved.
 *
 * MemoEnDe.h
 *
 */

#define UD_DIGEST_SIZE 16	// size of password digest
#define UD_ENCKEY_SIZE 8	// size of encryption key

typedef struct {
	Word	count;
	Byte	pwdod[16];		// digest of password digest
	Word	dummy1;
	Word	dummy2;
	Word	dummy3;
	Word	dummy4;
	Word	dummy5;
} PrefType;

typedef struct {

	DWord	encrypt_list;	// encryptions scheme available
	DWord	encrypt_user;	// user selected encrypt scheme

	Word    record;			// current record
	Boolean encode;			// if current record is encoded
	Boolean dummy;

	char	signature[128];	// signature of an encoded memo
	ULong	sign_size;		// length of "don't edit" heaader
	char	checksum[8];	// content crc (value in word) "hhhh \n\n"
	ULong	csum_size;		// length of checksum
	ULong	head_size;		// length of header (signature + checksum)

	Boolean	password_set;	// flag if password is set
	Byte	password[16];	// password digest

} EnDeType;

extern PrefType pref;
extern EnDeType ende;

#define UD_NO_ENDE	0		// no encryption/decryption in system

#define UD_ENDE_ID	'SaFE'
#define UD_VERSION	10

Boolean	ende_init();
		
Boolean ende_digest_defed(Byte digest[16], Byte size);
Boolean	ende_password_1st();			// init password
void	ende_password_set(Byte pw[16]); // runtime password
Boolean	ende_ask_password(char *title, Byte pw[16]);
Boolean ende_password_ok(Byte pw[16], Byte size);

void	ende_change_password(); // create new password
void	ende_forget_password(); // forget runtime password

void	ende_set_checksum(char *s, Word x);
Word	ende_get_checksum(char *s);

void	ende_set_signature(Word x);

Boolean ende_is_record_encoded(DmOpenRef db, Word record);
Boolean ende_is_text_encoded(const char* s, ULong *title_size, ULong *coded_size);

Boolean ende_get_record_encode(Word record);
void    ende_set_record_encode(Word record, Boolean encode);

void    ende_decode_record(DmOpenRef db, Word record);
void    ende_encode_record(DmOpenRef db, Word record);

VoidHand ende_decode_text(char *ptr, ULong title_size, ULong signature_size, ULong plain_size);
VoidHand ende_encode_text(char *ptr, ULong title_size, ULong signature_size, ULong plain_size);

ULong	ende_64_encode_size(ULong de_size);
ULong	ende_64_decode_size(ULong en_size);

Err		ende_64_encode(unsigned char *de, Long de_size, unsigned char *en, Long en_size);
Err		ende_64_decode(unsigned char *en, Long en_size, unsigned char *de, Long de_size);

void	uiAboutSafe();
void 	uiSetText(FormPtr, Word fID, CharPtr fData, ULong fSize);
char*	uiGetText(FormPtr, Word fID);
void	uiDrawBitmap(int bmID, short scrnx, short scrny);
void	uiEraseRect(short scrnx, short scrny, short bmW, short bmH);
